motor/urls.py
from django.conf.urls import patterns, include, url
from django.views.generic import TemplateView
from apps.core.views import *
from apps.issues.views import *

from django.contrib import admin
admin.autodiscover()

urlpatterns = patterns(
    '',
    #url(r'^$', 'docs.views.index', name='docs-index'),
    url(r'^$', welcome, name='issues-welcome'),
    url(r'^issues/thanks/$', thanks, name='issues-thanks'),
    url(r'^issues/notes/$', details, name='issues-details'),
    url(r'^issues/notes/([a-z]+)/$', details, name='issues-details'),
    url(r'^issues/(\d+)?/$', list_issues, name='issues-index'),
    url(r'^issues/devices/$', choose_device, name='issues-choose_device'),
    url(r'^issues/devices/([a-z]+)/$', choose_device, name='issues-choose_device'),
    url(r'^issues/warranty/$', warranty, name='issues-warranty'),
    url(r'^issues/customer/$', customer, name='issues-customer'),
    url(r'^manage/$', LoginView.as_view(), name='core-login'),
    url(r'^manage/logout/$', logout, name='core-logout'),
    url(r'^manage/docs/$', ArticleListView.as_view(), name='core-list_docs'),
    url(r'^manage/docs/add/$', ArticleCreateView.as_view(), name='core-add_article'),
    url(r'^manage/docs/(?P<pk>\d+)/$', ArticleEditView.as_view(), name='core-edit_article'),
    url(r'^manage/users/$', UserListView.as_view(), name='core-list_users'),
    url(r'^manage/users/(?P<pk>\d+)/$', UserEditView.as_view(), name='core-edit_user'),
    url(r'^manage/users/add/$', UserCreateView.as_view(), name='core-add_user'),
    url(r'^manage/providers/$', ProvidersListView.as_view(), name='core-list_sites'),
    url(r'^manage/providers/(?P<pk>\d+)/$', ProviderEditView.as_view(), name='core-edit_provider'),
    url(r'^manage/providers/add/$', CreateSiteView.as_view(), name='core-add_site'),
    url(r'^manage/issues/$', IssueListView.as_view(), name='issues-list_issues'),
    url(r'^manage/issues/add/$', IssueCreateView.as_view(), name='issues-add_issue'),
    url(r'^manage/issues/(?P<pk>\d+)/$', IssueEditView.as_view(), name='issues-edit_issue'),
    url(r'^terms/$', TemplateView.as_view(template_name="terms.html"),
        {'title': 'ServoApp Terms of Service'}),
    (r'^admin/', include(admin.site.urls)),
   #url(r'^([\w\-]+)/$', 'docs.views.view_article', name='docs-view'),
)

apps/issues/models.py
from django.db import models
from django.utils.translation import ugettext as _

from apps.core.models import ServiceProvider
from apps.checkin.models import ServiceOrder


class Issue(models.Model):
    sp = models.ForeignKey(ServiceProvider)
    keywords = models.TextField(default='')
    description = models.CharField(max_length=256, default=_('No power'))

    def __unicode__(self):
        return self.description

    def get_absolute_url(self):
        return '/manage/issues/%d/' % self.pk


class Question(models.Model):
    issue = models.ForeignKey(Issue)
    question = models.CharField(max_length=256)
    description = models.TextField(default='')
    required = models.BooleanField(default=True)

    def next(self):
        return Question.objects.get(issue=self.issue, pk__gt=self.pk)

    def prev(self):
        return Question.objects.get(issue=self.issue, pk__lt=self.pk)

    def __unicode__(self):
        return self.question


class Choice(models.Model):
    question = models.ForeignKey(Question)
    choice = models.CharField(max_length=256)

    def __unicode__(self):
        return self.choice


class Answer(models.Model):
    choice = models.ForeignKey(Choice)
    answer = models.CharField(max_length=256)
    so = models.ForeignKey(ServiceOrder)

apps/issues/forms.py
from django import forms
from apps.issues.models import Issue


class IssueForm(forms.ModelForm):
    class Meta:
        model = Issue

apps/issues/views.py
from django import forms
from gsxws import products
from django.shortcuts import render, redirect
from django.views.generic.list import ListView
from django.utils.translation import ugettext as _
from django.views.generic.edit import FormView, CreateView, UpdateView
from apps.core.views import DefaultEditView, DefaultListView
from apps.issues.models import Issue, Question, Choice


class WarrantyForm(forms.Form):
    sn = forms.CharField(
        required=False,
        initial='DGKFL06JDHJP',
        label=_('Serial number')
    )


class IssueForm(forms.Form):
    description = forms.CharField(
        required=False,
        widget=forms.Textarea()
    )
    attachment = forms.FileField(required=False)


class CustomerForm(forms.Form):
    fname = forms.CharField(label=_('First name'), initial='Filipp')
    lname = forms.CharField(label=_('Last name'), initial='Lepalaan')
    email = forms.EmailField(label=_('Email'), initial='filipp@fps.ee')
    phone = forms.CharField(label=_('Phone number'), initial='451202717')
    address = forms.CharField(label=_('Address'), initial='Kustaankatu 2 C 96')
    city = forms.CharField(label=_('City'), initial='Helsinki')
    postal_code = forms.CharField(label=_('Postal code'), initial='00500')


class IssueListView(DefaultListView):
    model = Issue


class IssueCreateView(CreateView):
    model = Issue
    template_name = 'core/form.html'
    success_url = '/manage/issues/'


class IssueEditView(DefaultEditView):
    model = Issue


def welcome(request):
    form = WarrantyForm()
    return render(request, "issues/welcome.html", locals())


def details(request, device=None):
    form = IssueForm()

    if request.method == "POST":
        request.session['details'] = request.POST.get('details')
        return redirect(list_issues)

    return render(request, "issues/details.html", locals())


def list_issues(request, idx=None):
    questions = Question.objects.filter(issue__sp_id=1)

    if idx is None:
        question = questions[0]
        request.session['choices'] = []
    else:
        choice = Choice.objects.get(pk=idx)
        current = questions.get(choice=idx)
        current.choice = choice
        request.session['choices'].append(current)
        try:
            question = current.next()
        except Question.DoesNotExist:
            return redirect(customer)

    dump = request.session.get('choices')
    return render(request, "issues/question.html", locals())


def choose_device(request, device=None):
    models = products.models()
    tpl = "issues/%s.html" % (device or 'device')
    return render(request, tpl, locals())


def warranty(request):
    return render(request, "issues/warranty.html", locals())


def thanks(request):
    return render(request, "issues/thanks.html", locals())


def customer(request):
    form = CustomerForm()
    if request.method == "POST":
        form = CustomerForm(request.POST)
        if form.is_valid():
            return redirect(thanks)

    return render(request, "issues/customer.html", locals())


def restart(request):
    request.session = None
    return redirect(welcome)

templates/issues/customer.html
{% extends "issues/index.html" %}
{% load bootstrap3 %}
{% load i18n %}

{% block nav %}
    <li><a href="#">{% trans "Product" %}</a></li>
    <li><a href="#">{% trans "Issue" %}</a></li>
    <li class="active"><a href="#">{% trans "Your info" %}</a></li>
    <li><a href="#">{% trans "Done" %}</a></li>
{% endblock nav %}

{% block main %}
    <h2>3. {% trans "Your info" %}</h2>
    <form method="post" action="">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
        <button type="submit" class="btn btn-primary">{% trans "Submit" %}</button>
    {% endbuttons %}
    </form>
{% endblock main %}

templates/issues/details.html
{% extends "issues/index.html" %}
{% load bootstrap3 %}
{% load i18n %}

{% block main %}
    <h2>2. {% trans "The Issue" %}</h2>
    <p>Please describe the issue you're having with the product.</p>
    <form method="post" action="{% url 'issues-details' %}" enctype="multipart/form-data">
        {% csrf_token %}
        {% bootstrap_form form %}
        <div class="form-group text-center">
            <button type="submit" class="btn btn-primary">{% trans "Continue" %}</button>
        </div>
    </form>
{% endblock main %}

templates/issues/device.html
{% extends "issues/warranty.html" %}
{% load i18n %}

{% block main %}
<h2>{% trans "Choose Your Device" %}</h2>
<p>Help text..</p>
<div class="devices">
    <div class="row">
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'mac' %}">
                <img src="{{ STATIC_URL }}img/products/mac.png"/>
                <div>{% trans "Mac" %}</div>
            </a>
        </div>
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'ipod' %}">
                <img src="{{ STATIC_URL }}img/products/ipod.png"/>
                <div>{% trans "iPod" %}</div>
            </a>
        </div>
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'iphone' %}">
                <img src="{{ STATIC_URL }}img/products/iphone.png"/>
                <div>{% trans "iPhone" %}</div>
            </a>
        </div>
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'ipad' %}">
                <img src="{{ STATIC_URL }}img/products/ipad.png"/>
                <div>{% trans "iPad" %}</div>
            </a>
        </div>
    </div>
    <div class="row">
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'other' %}">
                <img src="{{ STATIC_URL }}img/products/other.png"/>
                <div>{% trans "Other" %}</div>
            </a>
        </div>
    </div>
</div>
{% endblock main %}

templates/issues/index.html
{% load i18n %}
<!DOCTYPE html>
<html>
<head>
    <title>{{ title }}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- Bootstrap -->
    <link href="{{ STATIC_URL }}bootstrap/css/bootstrap.min.css" rel="stylesheet" media="screen">
    <link href="{{ STATIC_URL }}bootstrap/css/bootstrap-theme.min.css" rel="stylesheet" media="screen">
    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
      <script src="https://oss.maxcdn.com/libs/respond.js/1.3.0/respond.min.js"></script>
    <![endif]-->
    <style type="text/css">
        body {
            padding-top: 20px;
        }
        .devices > div {
            text-align: center;
        }
        .devices > div div {
            padding: 10px;
        }
        label {
            display: none;
        }
    </style>
  </head>
  <body>
    <div class="container">
        <div class="navbar navbar-default" role="navbar">
            <ul class="nav navbar-nav">
            {% block nav %}
                <li><a href="#">{% trans "Product" %}</a></li>
                <li class="active"><a href="#">{% trans "Issue" %}</a></li>
                <li><a href="#">{% trans "Your info" %}</a></li>
                <li><a href="#">{% trans "Done" %}</a></li>
            {% endblock nav %}
            </ul>
        </div>
        {% block main %}
        {% endblock main %}
    </div><!-- /container -->
    <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
    <script src="{{ STATIC_URL }}js/jquery.min.js"></script>
    <!-- Include all compiled plugins (below), or include individual files as needed -->
    <script src="{{ STATIC_URL }}bootstrap/js/bootstrap.min.js"></script>
    </body>
</html>

templates/issues/iphone.html
{% extends "issues/device.html" %}

templates/issues/ipod.html
{% extends "issues/device.html" %}
{% load i18n %}

{% block main %}
    <h2>{% trans "iPod" %}</h2>
    <div class="row">
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/ipodtouch.png"/>
                <div>{% trans "iPod touch" %}</div>
            </a>
        </div>
        <div class="col-md-3">
            <a href="{% url 'issues-choose_device' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/ipodtouch.png"/>
                <div>{% trans "iPod touch" %}</div>
            </a>
        </div>
    </div>    
{% endblock main %}

templates/issues/mac.html
{% extends "issues/device.html" %}
{% load i18n %}

{% block main %}
<h2>{% trans "Mac" %}</h2>
<p>{% trans "Choose your Mac" %}</p>
<div class="devices">
    <div class="row">
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/macbook.png"/>
                <div>{% trans "MacBook" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'ipod' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/macbookpro.png"/>
                <div>{% trans "MacBook Pro" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'iphone' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/macbookair.png"/>
                <div>{% trans "MacBook Air" %}</div>
            </a>
        </div>
    </div>
    <div class="row">
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'ipad' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/imac.png"/>
                <div>{% trans "iMac" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'ipad' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/macpro.jpg"/>
                <div>{% trans "Mac Pro" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'ipad' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/macmini.png"/>
                <div>{% trans "Mac mini" %}</div>
            </a>
        </div>
    </div>
</div>    
{% endblock main %}

templates/issues/other.html
{% extends "issues/device.html" %}
{% load i18n %}

{% block main %}
<h2>{% trans "Other" %}</h2>
<p>{% trans "Choose your product" %}</p>
<div class="devices">
    <div class="row">
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/wifi.png"/>
                <div>{% trans "AirPort Express" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/wifi.png"/>
                <div>{% trans "AirPort Express" %}</div>
            </a>
        </div>
        <div class="col-md-4">
            <a href="{% url 'issues-details' 'mac' %}">
                <img class="img-responsive" src="{{ STATIC_URL }}img/products/wifi.png"/>
                <div>{% trans "AirPort Time Capsule" %}</div>
            </a>
        </div>
    </div>
</div>
{% endblock main %}

templates/issues/question.html
{% extends "issues/index.html" %}
{% load i18n %}

{% block main %}
<div style="text-align:center">
    <h1>{{ question.question }}</h1>
    <p>{{ question.description|default:"" }}</p>
    {% for i in question.choice_set.all %}
        <a class="btn btn-default" href="{% url 'issues-index' i.pk %}">{{ i.choice }}</a>
    {% endfor %}
</div>
{% endblock main %}

templates/issues/thanks.html
{% extends "issues/index.html" %}
{% load i18n %}

{% block nav %}
    <li><a href="#">{% trans "Product" %}</a></li>
    <li><a href="#">{% trans "Issue" %}</a></li>
    <li><a href="#">{% trans "Your info" %}</a></li>
    <li class="active"><a href="#">{% trans "Done" %}</a></li>
{% endblock nav %}

{% block main %}
<div style="text-align:center">
    <h1>{% trans "Thanks!" %}</h1>
    <img src="{{ STATIC_URL }}img/products/done.png" alt=""/><br/>
    <p>Put description here...</p>
    <a class="btn btn-primary" href="{% url 'issues-welcome' %}"><i class="glyphicon glyphicon-repeat"></i> {% trans "Restart" %}</a>
</div>
{% endblock main %}

templates/issues/warranty.html
{% extends "issues/index.html" %}
{% load i18n %}

{% block nav %}
    <li class="active"><a href="#">{% trans "Product" %}</a></li>
    <li><a href="#">{% trans "Issue" %}</a></li>
    <li><a href="#">{% trans "Your info" %}</a></li>
    <li><a href="#">{% trans "Done" %}</a></li>
{% endblock nav %}

{% block main %}
    <div class="row">
        <div class="col-md-5">
            <img src="http://service.info.apple.com/parts/service_parts/products/imac_27_mid2011.jpg" alt="iMac (27-inch, Mid 2011)" title="iMac (27-inch, Mid 2011)">
        </div>
        <div class="col-md-7">
            <div style="padding: 20px">
                <h3>iMac (27-inch, Mid 2011)</h3>
                <dl class="dl-horizontal">
                    <dt>{% trans "Warranty" %}</dt>
                    <dd>Out Of Warranty (No Coverage)</dd>
                    <dt>{% trans "Purchased" %}</dt>
                    <dd>2.6.2011, Sweden</dd>
                    <dt>{% trans "Serial Number" %}</dt>
                    <dd>DGKFL06JDHJP</dd>
                    <dt>{% trans "Configuration" %}</dt>
                    <dd>IMAC 27"/2.7QC/2X2GB/1TB/6770M</dd>
                </dl>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12 text-center">
            <a class="btn btn-primary" href="{% url 'issues-details' %}">{% trans "Continue" %}</a>
        </div>
    </div>
{% endblock main %}

templates/issues/welcome.html
{% extends "issues/index.html" %}
{% load bootstrap3 %}
{% load i18n %}

{% block nav %}
    <li class="active"><a href="#">{% trans "Product" %}</a></li>
    <li><a href="#">{% trans "Issue" %}</a></li>
    <li><a href="#">{% trans "Your info" %}</a></li>
    <li><a href="#">{% trans "Done" %}</a></li>
{% endblock nav %}

{% block main %}
<h2>1. {% trans "Product" %}</h2>
<p>Let's start by identifying your device. Please enter your <a href="http://support.apple.com/kb/HT1349" target="_blank">serial number</a> or click Skip.</p>
<form method="post" action="{% url 'issues-warranty' %}">
    {% csrf_token %}
    {% bootstrap_form form %}
    <div class="form-group">
        <a href="{% url 'issues-choose_device' %}" class="btn btn-default">{% trans "Skip" %}</a>
    </div>
</form>
{% endblock main %}